%define	major	6
%define	libname	%mklibname %{name} %{major}
%define	libhist	%mklibname history %{major}
%define	devname	%mklibname %{name} -d

%bcond_without	uclibc

Summary:	Library for reading lines from a terminal
Name:		readline
Version:	6.2
Release:	7
License:	GPLv2+
Group:		System/Libraries
Url:		http://tiswww.case.edu/php/chet/readline/rltop.html
Source0:	ftp://ftp.gnu.org/gnu/readline/%{name}-%{version}.tar.gz
Source1:	ftp://ftp.gnu.org/gnu/readline/%{name}-%{version}.tar.gz.sig
Patch0:		readline-4.3-no_rpath.patch
Patch3:		readline-4.1-outdated.patch
Patch4:		rl-header.patch
Patch5:		rl-attribute.patch
Patch6:		readline-6.0-fix-shared-libs-perms.patch
Patch7:		readline62-001
Patch8:		readline-6.2-fix-missing-linkage.patch
BuildRequires:	ncurses-devel
%if %{with uclibc}
BuildRequires:	uClibc-devel >= 0.9.33.2-11
%endif

%description
The "readline" library will read a line from the terminal and return it,
allowing the user to edit the line with the standard emacs editing keys.
It allows the programmer to give the user an easier-to-use and more
intuitive interface.

%package -n	%{libname}
Summary:	Shared libreadline library for readline
Group:		System/Libraries
Provides:	%{name} = %{EVRD}

%description -n	%{libname}
This package contains the library needed to run programs dynamically
linked to readline.

%package -n	uclibc-%{libname}
Summary:	Shared libreadline library for readline (uClibc build)
Group:		System/Libraries

%description -n	uclibc-%{libname}
This package contains the library needed to run programs dynamically
linked to readline.

%package -n	%{libhist}
Summary:	Shared libhistory library for readline
Group:		System/Libraries
Conflicts:	%{libname} < 6.2-6

%description -n	%{libhist}
This package contains the libhistory library from readline.

%package -n	uclibc-%{libhist}
Summary:	Shared libhistory library for readline (uClibc Build)
Group:		System/Libraries

%description -n	uclibc-%{libhist}
This package contains the libhistory library from readline.

%package	doc
Summary:	Readline documentation in GNU info format
Group:		Books/Computer books
Provides:	%{name}-doc = %{EVRD}
Obsoletes:	%{libname}-doc
BuildArch:	noarch

%description	doc
This package contains readline documentation in the GNU info format.

%package -n	%{devname}
Summary:	Files for developing programs that use the readline library
Group:		Development/C
Requires:	%{libname} = %{EVRD}
Requires:	%{libhist} = %{EVRD}
%if %{with uclibc}
Requires:	uclibc-%{libname} = %{EVRD}
Requires:	uclibc-%{libhist} = %{EVRD}
%endif
Provides:	%{name}-devel = %{EVRD}
Obsoletes:	%{mklibname readline 5 -d}

%description -n	%{devname}
The "readline" library will read a line from the terminal and return it,
using prompt as a prompt.  If prompt is null, no prompt is issued.  The
line returned is allocated with malloc(3), so the caller must free it when
finished.  The line returned has the final newline removed, so only the
text of the line remains.

%prep
%setup -q
%patch0 -p1 -b .no_rpath
%patch3 -p1 -b .outdated
%patch4 -p1 -b .header
%patch5 -p1 -b .attribute
%patch6 -p1 -b .fix-perms
%patch7 -p0 -b .001
%patch8 -p1 -b .libs~

sed -e 's#/usr/local#%{_prefix}#g' -i doc/texi2html
libtoolize --copy --force

%build
CONFIGURE_TOP=$PWD

%if %{with uclibc}
mkdir -p uclibc
pushd uclibc
%configure2_5x	CC="%{uclibc_cc}" \
		CFLAGS="%{uclibc_cflags}" \
		--libdir=%{uclibc_root}%{_libdir} \
		--enable-static=no \
		--with-curses \
		--enable-multibyte

%make
popd
%endif

mkdir -p system
pushd system
%configure2_5x	--enable-static=no \
		--with-curses \
		--enable-multibyte

%make
popd

%install
%if %{with uclibc}
%makeinstall_std -C uclibc
install -d %{buildroot}%{uclibc_root}/%{_lib}
for l in libhistory.so libreadline.so; do
	rm %{buildroot}%{uclibc_root}%{_libdir}/${l}
	mv %{buildroot}%{uclibc_root}%{_libdir}/${l}.%{major}* %{buildroot}%{uclibc_root}/%{_lib}
	ln -sr %{buildroot}%{uclibc_root}/%{_lib}/${l}.%{major}.* %{buildroot}%{uclibc_root}%{_libdir}/${l}
done
%endif

%makeinstall_std -C system
# put all libs in /lib because some package needs it
# before /usr is mounted
install -d %{buildroot}/%{_lib}
for l in libhistory.so libreadline.so; do
	rm %{buildroot}%{_libdir}/${l}
	mv %{buildroot}%{_libdir}/${l}.%{major}* %{buildroot}/%{_lib}
	ln -sr %{buildroot}/%{_lib}/${l}.%{major}.* %{buildroot}%{_libdir}/${l}
done

%files -n %{libname}
/%{_lib}/libhistory.so.%{major}*

%files -n %{libhist}
/%{_lib}/libreadline.so.%{major}*

%if %{with uclibc}
%files -n uclibc-%{libname}
%{uclibc_root}/%{_lib}/libhistory.so.%{major}*

%files -n uclibc-%{libhist}
%{uclibc_root}/%{_lib}/libreadline.so.%{major}*
%endif

%files doc
%{_infodir}/history.info*
%{_infodir}/readline.info*
%{_infodir}/rluserman.info*

%files -n %{devname}
%doc CHANGELOG CHANGES MANIFEST README USAGE
%doc doc examples support
%{_mandir}/man3/*
%{_includedir}/readline
%{_libdir}/libhistory.so
%{_libdir}/libreadline.so
%if %{with uclibc}
%{uclibc_root}%{_libdir}/libhistory.so
%{uclibc_root}%{_libdir}/libreadline.so
%endif


%changelog
* Wed Oct 03 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 6.2-7
+ Revision: 818319
- rebuild to get proper provides/requires for uclibc build

* Thu Sep 27 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 6.2-6
+ Revision: 817733
- drop useless dependency on library package for doc package
- make doc package noarch
- package individual libhistory & libreadline libraries separately
- don't build static library at all or install source under %%{_datadir}/readline
- fix paths in doc/texi2html in %%prep in stead
- do uclibc build

* Sun Jun 03 2012 Andrey Bondrov <abondrov@mandriva.org> 6.2-5
+ Revision: 802121
- Drop some legacy junk

* Wed Mar 07 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 6.2-4
+ Revision: 782700
- install rluserman info page
- cleanups
- use %%{EVRD} macro
- drop ancient obsoletes
- drop excessive provides & requires
- update buildrequires

* Thu Dec 15 2011 Oden Eriksson <oeriksson@mandriva.com> 6.2-3
+ Revision: 741623
- various cleanups

* Wed Apr 20 2011 Tomasz Pawel Gajc <tpg@mandriva.org> 6.2-2
+ Revision: 656341
- Patch7: fix vi-mode commands (from upstream)

* Thu Feb 17 2011 Oden Eriksson <oeriksson@mandriva.com> 6.2-1
+ Revision: 638150
- 6.2
- drop upstream added patches

* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 6.1-3mdv2011.0
+ Revision: 607337
- rebuild

* Wed Mar 31 2010 Guillaume Rousse <guillomovitch@mandriva.org> 6.1-2mdv2010.1
+ Revision: 530534
- apply 2 official patches

* Sat Jan 02 2010 Frederik Himpe <fhimpe@mandriva.org> 6.1-1mdv2010.1
+ Revision: 484989
- Update to new version 6.1
- Remove patches integrated upstream

* Sun Jun 28 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 6.0-2mdv2010.0
+ Revision: 390322
- add three upstream patches
- spec file clean

* Tue Feb 24 2009 Guillaume Rousse <guillomovitch@mandriva.org> 6.0-1mdv2009.1
+ Revision: 344412
- new version
- drop merged patches
- drop undocumented readline-5.2-inv.patch
- new devel policy
- rename doc package to readline-doc

* Wed Jan 14 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 5.2-11mdv2009.1
+ Revision: 329253
- enable multibyte characters

* Mon Dec 22 2008 Oden Eriksson <oeriksson@mandriva.com> 5.2-10mdv2009.1
+ Revision: 317557
- rebuild

* Thu Aug 07 2008 Thierry Vignaud <tv@mandriva.org> 5.2-9mdv2009.0
+ Revision: 265632
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Wed May 28 2008 Funda Wang <fwang@mandriva.org> 5.2-8mdv2009.0
+ Revision: 212604
- add more ubuntu patches
- hardlink against ncurses

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - add requires on libncurses-devel for devel package

  + Thierry Vignaud <tv@mandriva.org>
    - fix no-buildroot-tag

* Mon Dec 31 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 5.2-7mdv2008.1
+ Revision: 139706
- new license policy
- use upstream source file, add *.sig
- reorganize patches
- add ten upstream patches - mostly they fixes displaying characters under bash, more info can be found in each patch file
- compile against ncurses
- use macros
- make use of %%major in spec file
- spec file clean

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Sep 19 2007 Guillaume Rousse <guillomovitch@mandriva.org> 5.2-6mdv2008.0
+ Revision: 90249
- rebuild

* Tue Sep 18 2007 Anssi Hannula <anssi@mandriva.org> 5.2-5mdv2008.0
+ Revision: 89540
- rebuild due to package loss

* Thu Jun 07 2007 Anssi Hannula <anssi@mandriva.org> 5.2-4mdv2008.0
+ Revision: 36197
- rebuild with correct optflags

  + Thierry Vignaud <tv@mandriva.org>
    - kill bogus patch 5 (#28432), add by Geoffrey Lee in 4.1-15mdk on behalf of
      <mlord@pobox.com>, with no explanation

* Mon May 28 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 5.2-2mdv2008.0
+ Revision: 32180
+ rebuild (emptylog)

* Mon May 28 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 5.2-1mdv2008.0
+ Revision: 32035
- introduce readline-doc package, with info documentation. The
  manuals were on the -devel package, but they're of general use.


* Thu Feb 01 2007 Emmanuel Andry <eandry@mandriva.org> 5.2-1mdv2007.0
+ Revision: 115840
- New version 5.2
- drop patches 11 and 18
- add upstream patch (P12)

* Sun Oct 15 2006 Oden Eriksson <oeriksson@mandriva.com> 5.1-3mdv2007.0
+ Revision: 64867
- bzip2 cleanup
- rebuild

* Thu Oct 12 2006 Oden Eriksson <oeriksson@mandriva.com> 5.1-2mdv2007.1
+ Revision: 63476
- bunzip patches
- Import readline

* Wed Jan 04 2006 Thierry Vignaud <tvignaud@mandriva.com> 5.1-1mdk
- new release
- drop patch 2 (was merged long ago but was still wrongly aplied because patch
  defaults to -F 2 :-( )
- drop patch 4 (rh patch dropped in fedora)
- drop patch 17 (merged upstream)
- drop patches 11 to 15 (upstream patches)
- patch 11: add official patch

* Sun Jan 01 2006 Mandriva Linux Team <http://www.mandrivaexpert.com/> 5.0-3mdk
- Rebuild

* Sun Jan 23 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 5.0-2mdk
- from fedora:
	o Fix line-wrapping (bug #145329).
	o Apply "read -e" patch from bash package.

* Thu Jan 20 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 5.0-1mdk
- 5.0
- bump major
- sync with fedora patches
- drop P1 (weren't applied), P100 & P101 (merged upstream)
- add url
- cosmetics

* Wed Dec 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 4.3-9mdk
- revert latest "lib64 fixes"

* Wed Dec 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 4.3-8mdk
- lib64 fixes

